#include <iostream>
#include <chrono>
#include "tick.h"


/*
  The function 'Count_Ticks' cannot be optimized!
  So, the following function attributes disable its optimization for gcc and clang.
  GCC 4.7 supports C++11
  https://gcc.gnu.org/projects/cxx-status.html#cxx11
  Clang 3.3 supports C++11
  https://clang.llvm.org/cxx_status.html#cxx11
*/
#if defined(__GNUC__) && (__GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 7))
uint64_t Count_Ticks(uint64_t ticks) __attribute__ ((optimize("0")));
uint64_t Count_Time(uint64_t ticks) __attribute__ ((optimize("0")));
#elif defined(__clang__) && (__clang_major__ > 3 || (__clang_major__ == 3 && __clang_minor__ >= 3))
uint64_t Count_Ticks(uint64_t ticks) __attribute__ ((optnone));
uint64_t Count_Time(uint64_t ticks) __attribute__ ((optnone));
#warning "The Clang is not recommended due to limitation in the ticks generation"

/* I suggest NOT TO USE CLANG, at least for this part of the code due to the following limitation.
With Clang (v11 used), every xor will be transformed into a load, a xor, and a store instruction 
while that with GCC it only generates a xor instruction. The additional instructions is not much 
of a deal. The point is that it generated a lot of memory access in a part of amalthea code that 
should only waste time, without disturbing other parts of the computing system. 

This is an example of ASM generated by clang with -O0:

movzx   esi, byte ptr [rbp - 33]
xor     esi, 1
mov     byte ptr [rbp - 33], sil

while GCC generats only:

xor    ebx,0x1

where there is no memory access at all.

Any other optimization level, no matter the compiler used, will wipe out the entire code.

This clang limitation related to internal register allocation is discussed here:
https://stackoverflow.com/questions/55648274/why-does-clang-behave-weirdly-with-register-variables-compared-to-gcc
*/
#else
#error "Unsupported compiler. Expecting gcc 7.0 or newer, or clang 10 or newer"
#endif

uint64_t Count_Time(uint64_t ticks){
   register uint64_t i=0,j=0;
   register uint64_t dur=0;
   std::chrono::steady_clock::time_point begin = std::chrono::steady_clock::now();
   std::chrono::steady_clock::time_point end = std::chrono::steady_clock::now();
   while (dur < ticks) {
      begin = std::chrono::steady_clock::now();
      for(j=0;j<1000000;j++);
      end = std::chrono::steady_clock::now();
      dur += std::chrono::duration_cast<std::chrono::microseconds>(end - begin).count();
      i++;
   }
   return i;
}



uint64_t Count_Ticks(uint64_t ticks){
   // 256 is the number of ops inside the 1st while loop
   // left_over is the remaining ticks, but 4 with ops per iteration
   register uint64_t left_over = (ticks & !(256-1))/4;
   register uint64_t numLoops = ticks / 256; 
   register uint32_t nop=0;
   register uint64_t i=0;
   for (i = 0; i < numLoops; i++) {
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
   }
   for (i = 0; i < left_over; i++) {
      nop ^=1;
      nop ^=1;
      nop ^=1;
      nop ^=1;
   }   
   return nop;
}


Tick_DiscreteValueConstant::Tick_DiscreteValueConstant(int value)
{
   this->value_ = value;
}

int Tick_DiscreteValueConstant::operator()()
{
   return this->value_;
}

Tick_DiscreteValueStatistics::Tick_DiscreteValueStatistics(unsigned seed, int low, int high, float avg, float std_dev)
: random_engine_{std::default_random_engine{seed}}
, distribution_{avg, std_dev}
{
   this->min_ = low;
   this->max_ = high;
}

int Tick_DiscreteValueStatistics::operator()()
{
   int val;
   // only accept values within the min and max
   do {
      val = (int)std::round(distribution_(random_engine_));
   }while ( ! (val >= this->min_ && val <= this->max_));
#  ifdef DEBUG_EXTRA
   printf("tick: %d\n", val);
#  endif
   return val;
}

Tick_DiscreteValueGaussDistribution::Tick_DiscreteValueGaussDistribution(unsigned seed, int low, int high, float avg, float std_dev)
: random_engine_{std::default_random_engine{seed}}
, distribution_{avg, std_dev}
{
   this->min_ = low;
   this->max_ = high;
}

int Tick_DiscreteValueGaussDistribution::operator()()
{
   int val;
   // only accept values within the min and max
   do {
      val = (int)std::round(distribution_(random_engine_));
   }while ( ! (val >= this->min_ && val <= this->max_));
#  ifdef DEBUG_EXTRA
   printf("tick: %d\n", val);
#  endif
   return val;
}

Tick_DiscreteValueWeibullEstimatorsDistribution::Tick_DiscreteValueWeibullEstimatorsDistribution(unsigned seed, int low, int high, float a, float b)
: random_engine_{std::default_random_engine{seed}}
, distribution_{a, b}
{
   this->min_ = low;
   this->max_ = high;
}

int Tick_DiscreteValueWeibullEstimatorsDistribution::operator()()
{
   int val;
   // only accept values within the min and max
   do {
      val = distribution_(random_engine_);
      val += this->min_;
   }while ( ! (val <= this->max_));
#  ifdef DEBUG_EXTRA
   printf("tick: %d\n", val);
#  endif
   return val;
}
